import Redis from 'ioredis'

export default class {
  constructor (conn) {
    this.redis = new Redis(conn)
  }

  save (id, user, ttl) {
    if (ttl) {
      this.redis.set(id, JSON.stringify({ id, user }), 'ex', ttl)
    } else {
      this.redis.set(id, JSON.stringify({ id, user }))
    }
  }

  async get (id) {
    const session = await this.redis.get(id)
    if (session) {
      return JSON.parse(session)
    }
    return session
  }

  async delete (id) {
    // Get session.
    const session = await this.redis.get(id)

    // Parse user object.
    const user = JSON.parse(session.toString())

    // Delete session.
    await this.redis.del(id)

    // Remove session from user's session set.
    await this.remove(user.id, id)
  }

  async add (id, item) {
    this.redis.sadd(id, item)
  }

  async remove (id, item) {
    this.redis.srem(id, item)
  }

  all (id)  {
    return new Promise(async (resolve, reject) => {
      const pipeline = this.redis.pipeline()
      for (session of await this.redis.get(id)) {
        pipeline.get(session)
      }
      pipeline.exec((_, results) => {
        resolve(results.map(r => r[1]))
      })
    })
  }

  clear (id)  {
    return new Promise(async (resolve, reject) => {
      const pipeline = this.redis.pipeline()
      for (session of await this.redis.get(id)) {
        pipeline.del(session)
      }
      pipeline.exec((_, results) => {
        resolve(this.redis.del(key))
      })
    })
  }
}
